package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConfRestricaoRutasDAO;
import com.rjconsultores.ventaboletos.entidad.ConfRestricaoRutas;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.ConfRestricaoRutasService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("confRestricaoRutasService")
public class ConfRestricaoRutasServiceImpl implements ConfRestricaoRutasService {

	@Autowired
	private ConfRestricaoRutasDAO confRestricaoRutasDAO;
	@Autowired
	private RutaService rutaService;

	@Override
	public List<ConfRestricaoRutas> obtenerTodos() {
		return confRestricaoRutasDAO.obtenerTodos();
	}

	@Override
	public ConfRestricaoRutas obtenerID(Integer id) {
		return confRestricaoRutasDAO.obtenerID(id);
	}

	@Override
	public ConfRestricaoRutas obtenerRutasTodos() {

		ConfRestricaoRutas entidad = new ConfRestricaoRutas();

		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);
		Ruta ruta = rutaService.obtenerID(-1);
		entidad.setRuta(ruta);

		return entidad;
	}

	@Override
	@Transactional
	public ConfRestricaoRutas suscribir(ConfRestricaoRutas entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoRutasDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public ConfRestricaoRutas actualizacion(ConfRestricaoRutas entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoRutasDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(ConfRestricaoRutas entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		confRestricaoRutasDAO.actualizacion(entidad);
	}
	
}
